package visualization6;

import java.util.HashMap;
import java.util.Map;

/**
 * 任意のオブジェクトに一意なインデックスを割り当てます。
 */

public class IndexMapper {
    private Map<Object, Integer> map = new HashMap<Object, Integer>();

    public int size() {
        return map.size();
    }

    public boolean contains(Object obj) {
        return map.containsKey(obj);
    }

    public void put(Object obj) {
        if (!contains(obj)) {
            map.put(obj, size());
        }
    }

    public int get(Object obj) {
        if (!contains(obj)) {
            throw new IllegalArgumentException("Object is not found.");
        }
        return map.get(obj);
    }
}
